const util = require('../../utils/util');
const request = require('../../utils/request');
const api = require('../../utils/api');
const yesterday = new Date(Date.now() - 864e5);
const todayStr = util.formatTime(new Date(Date.now()));
const yesterdayStr = util.formatTime(yesterday);

Page({
    data: {
        date: yesterdayStr,
        currentDate: yesterdayStr,

        groupArray: [], // 计划名称数组
        groupIndex: 0,
        currentGroupId: '',
        groupData: [], // 计划对象数组

        planArray: [],
        planIndex: 0,
        currentPlanId: '',
        planData: [],

        creativeArray: [],
        creativeIndex: 0,
        creativeId: '',
        creativeData: [],

        opts: {
            lazyLoad: true // 延迟加载组件
        },
        chartsData: [],
        chartsDateArray: [],

        consumeTotal: '', //累计消耗金额
        showPvTotal: '',//累计曝光PV
        showUvTotal: '',//累计曝光UV
        showPerCapitaTotal: '',//累计人均曝光次数
        clickPvTotal: '',//累计点击PV
        clickUvTotal: '',//累计点击UV
        clickRateTotal: '',//累计点击率
        callRateTotal: '',//累计唤端率
        cpmTotal: '',//累计千次曝光金额
        cpcTotal: '',

        consume: '',
        showPv: '',
        showUv: '',
        showPerCapita: '',
        clickPv: '',
        clickUv: '',
        clickRate: '',
        callRate: '',
        cpm: '',
        cpc: '',

        consumeDrr: '',
        showPvDrr: '',
        showUvDrr: '',
        showPerCapitaDrr: '',
        clickPvDrr: '',
        clickUvDrr: '',
        clickRateDrr: '',
        callRateDrr: '',
        cpmDrr: '',
        cpcDrr: '',

        consumeWb: '',
        showPvWb: '',
        showUvWb: '',
        showPerCapitaWb: '',
        clickPvWb: '',
        clickUvWb: '',
        clickRateWb: '',
        callRateWb: '',
        cpmWb: '',
        cpcWb: '',
        createTime: '',
        cpcRate: ''
    },

    onReady() {
        this.queryPlanData();
    },

    dateSelected(e) {
        this.setData({
            date: e.detail.value,
            currentDate: e.detail.value
        })
        this.creativeTotal(this.data.creativeId, e.detail.value);
    },
    planPickerChange(e) {
        let index = e.detail.value;
        console.log("planPickerChange>>>>>>>>>>>>>>", index);
        this.setData({
            planIndex: index,
            currentPlanId: this.data.planData[index].id
        })
        this.queryGroupSimple(this.data.currentPlanId);
    },

    groupPickerChange(e) {
        let index = e.detail.value;
        if (this.data.groupData.length > 0) {
            this.setData({
                groupIndex: index,
                currentGroupId: this.data.groupData[index].id
            })
            this.queryCreativeSimple(this.data.groupData[index].id)
        }
    },

    creativePickerChange(e) {
        let index = e.detail.value;
        if (this.data.creativeData.length > 0) {
            this.setData({
                creativeIndex: index,
                creativeId: this.data.creativeData[index].id
            })
            this.creativeTotal(this.data.creativeData[index].id, this.data.currentDate);
            // console.log("e>>>>>>>>>>", JSON.stringify(this.data.creativeData[index]));
        }


    },

    queryPlanData() {
        wx.showLoading({
            title: '加载中',
        })
        var that = this;
        request.Get(api.campaignSimple(), function (res) {
            wx.hideLoading();
            console.log("queryPlanData>>>>>>>>>>>>", JSON.stringify(res));
            if (res.code == '200') {
                if (res.data.length == 0) {
                    wx.showToast({
                        title: "没有推广计划可查询",
                        icon: 'none',
                        duration: 1500
                    })
                } else {
                    that.setData({
                        planData: res.data,
                        planArray: res.data.map(item => { return item.name }),
                        currentPlanId: res.data[0].id
                    })
                    that.queryGroupSimple(res.data[0].id);
                }
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },
    // 推广组下拉
    queryGroupSimple(planId) {
        var that = this;
        let data = { 'campaignId': planId };
        request.Get(api.groupSimple(), data, function (res) {
            wx.hideLoading();
            // console.log("queryGroupSimple>>>>>>>>>>>>",JSON.stringify(res));
            if (res.code == '200') {
                if (res.data.length == 0) {
                    wx.showToast({
                        title: "没有推广组可查询",
                        icon: 'none',
                        duration: 1500
                    })
                } else {
                    that.setData({
                        groupData: res.data,
                        groupArray: res.data.map(item => { return item.name }),
                        currentGroupId: res.data[0].id
                    })
                    that.queryCreativeSimple(res.data[0].id);
                }
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },
    // 推广创意下拉
    queryCreativeSimple(groupId) {
        var that = this;
        let data = { 'groupId': groupId };
        request.Get(api.creativeSimple(), data, function (res) {
            wx.hideLoading();
            console.log("queryCreativeSimple>>>>>>>>>>>>", JSON.stringify(res));

            if (res.code == '200') {
                if (res.data.length == 0) {
                    wx.showToast({
                        title: "没有推广创意可查询",
                        icon: 'none',
                        duration: 1500
                    })
                    that.setData({
                        creativeData: [],
                        creativeArray: [],
                        creativeId: ""
                    })
                } else {
                    that.setData({
                        creativeData: res.data,
                        creativeArray: res.data.map(item => { return item.name }),
                        creativeId: res.data[0].id
                    })
                    that.creativeTotal(res.data[0].id, that.data.currentDate);
                }
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },


    creativeTotal(creativeId, dateStr) {
        var that = this;
        let data = { 'date': dateStr, 'id': creativeId };
        request.Get(api.creativeTotal(), data, function (res) {
            if (res.code == '200') {
                console.log("creativeTotal>>>>>>>>>>>", JSON.stringify(res));
                that.setData({
                    consumeTotal: util.numberWithCommas(String(res.data.consumeTotal)),
                    showPvTotal: util.numberWithCommas(String(res.data.showPvTotal)),
                    showUvTotal: util.numberWithCommas(String(res.data.showUvTotal)),
                    showPerCapitaTotal: util.numberWithCommas(String(res.data.showPerCapitaTotal)),
                    clickPvTotal: util.numberWithCommas(String(res.data.clickPvTotal)),
                    clickUvTotal: util.numberWithCommas(String(res.data.clickUvTotal)),
                    clickRateTotal: util.numberWithCommas(String(res.data.clickRateTotal)),
                    callRateTotal: util.numberWithCommas(String(res.data.callRateTotal)),
                    cpmTotal: util.numberWithCommas(String(res.data.cpmTotal)),
                    cpcTotal: util.numberWithCommas(String(res.data.cpcTotal)),


                    consume: util.numberWithCommas(String(res.data.consume)),
                    showPv: util.numberWithCommas(String(res.data.showPv)),
                    showUv: util.numberWithCommas(String(res.data.showUv)),
                    showPerCapita: util.numberWithCommas(String(res.data.showPerCapita)),
                    clickPv: util.numberWithCommas(String(res.data.clickPv)),
                    clickUv: util.numberWithCommas(String(res.data.clickUv)),
                    clickRate: util.numberWithCommas(String(res.data.clickRate)),
                    callRate: util.numberWithCommas(String(res.data.callRate)),
                    cpm: util.numberWithCommas(String(res.data.cpm)),
                    cpc: util.numberWithCommas(String(res.data.cpc)),
                    consumeDrr: util.numberWithCommas(String(res.data.consumeDrr)),
                    showPvDrr: util.numberWithCommas(String(res.data.showPvDrr)),
                    showUvDrr: util.numberWithCommas(String(res.data.showUvDrr)),
                    showPerCapitaDrr: util.numberWithCommas(String(res.data.showPerCapitaDrr)),
                    clickPvDrr: util.numberWithCommas(String(res.data.clickPvDrr)),
                    clickUvDrr: util.numberWithCommas(String(res.data.clickUvDrr)),
                    clickRateDrr: util.numberWithCommas(String(res.data.clickRateDrr)),
                    callRateDrr: util.numberWithCommas(String(res.data.callRateDrr)),
                    cpmDrr: util.numberWithCommas(String(res.data.cpmDrr)),
                    cpcDrr: util.numberWithCommas(String(res.data.cpcDrr)),
                    consumeWb: util.numberWithCommas(String(res.data.consumeWb)),
                    showPvWb: util.numberWithCommas(String(res.data.showPvWb)),
                    showUvWb: util.numberWithCommas(String(res.data.showUvWb)),
                    showPerCapitaWb: util.numberWithCommas(String(res.data.showPerCapitaWb)),
                    clickPvWb: util.numberWithCommas(String(res.data.clickPvWb)),
                    clickUvWb: util.numberWithCommas(String(res.data.clickUvWb)),
                    clickRateWb: util.numberWithCommas(String(res.data.clickRateWb)),
                    callRateWb: util.numberWithCommas(String(res.data.callRateWb)),
                    cpmWb: util.numberWithCommas(String(res.data.cpmWb)),
                    cpcWb: util.numberWithCommas(String(res.data.cpcWb)),
                    createTime: util.numberWithCommas(String(res.data.createTime)),
                    cpcRate: util.numberWithCommas(String(res.data.cpcRate)),
                })
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        });
    },





})
