const util = require('../../utils/util');
const request = require('../../utils/request');
const api = require('../../utils/api');

const yesterday = new Date(Date.now() - 864e5);
const yesterdayStr = util.formatTime(yesterday);
Page({
    data: {
        date: yesterdayStr,
        consumeTotal:"",//累计消耗金额
        showPvTotal:"",//累计曝光PV
        showUvTotal:"",//累计曝光UV
        showPerCapitaTotal:"",//累计人均曝光次数
        clickPvTotal:"", //累计点击PV
        clickUvTotal:"",//累计点击UV
        clickRateTotal:"",//累计点击率
        callRateTotal:"",//累计唤端率
        cpmTotal:"",//累计cpm
        cpcTotal:"",//累计点击单价
        cpm:"", //累计每千曝光金额
        clickPv:"",//累计点击PV
        cpcRate:"",//累计点击单价
        opts: {
            lazyLoad: true // 延迟加载组件
        },
        chartsData:[],
        chartsDateArray:[],
      },
      onReady() {
        this.queryData(yesterdayStr);
      },

      drawCharts(){
        const self = this;
        self.chartComponent = self.selectComponent('#line-dom');
        self.chartComponent.init((canvas, width, height, F2) => {
            console.log("chartsData>>>>>>>>>>",self.data.chartsData);
            const data = self.data.chartsData;
               let chart = new F2.Chart({
                  el: canvas,
                  width,
                  height
                });
                chart.source(data, {
                  date: {
                    range: [0, 1],
                    ticks: self.data.chartsDateArray
                  },
                  value: {
                    tickCount: 10,
                    formatter(val) {
                      return val;//val.toFixed(1);
                    }
                  }
                });
              
                chart.line().position('date*value').color('type', val => {
                    return 'red';
                });
                chart.render();
                return chart;
        });
      },

      dateSelected(e) {
        this.setData({
          date: e.detail.value
        })
        this.queryData(String(e.detail.value));
      },

      queryData(date){
        wx.showLoading({
          title: '加载中',
        })
        let data = {'date':date};
        var that = this;
        request.Get(api.customerTotal(),data, function (data) {
          wx.hideLoading();
          if (data.code == "200") {
            if (data.data !== null) {
                let tempData = data.data;
                that.setData({
                    consumeTotal:util.numberWithCommas(String(tempData.consumeTotal)),//累计消耗金额
                    showPvTotal:util.numberWithCommas(String(tempData.showPvTotal)),//累计曝光PV
                    showUvTotal:util.numberWithCommas(String(tempData.showUvTotal)),//累计曝光UV
                    showPerCapitaTotal:util.numberWithCommas(String(tempData.showPerCapitaTotal)),//累计人均曝光次数
                    clickPvTotal:util.numberWithCommas(String(tempData.clickPvTotal)), //累计点击PV
                    clickUvTotal:util.numberWithCommas(String(tempData.clickUvTotal)),//累计点击UV
                    clickRateTotal:util.numberWithCommas(String(tempData.clickRateTotal)),//累计点击率
                    callRateTotal:util.numberWithCommas(String(tempData.callRateTotal)),//累计唤端率
                    cpmTotal:util.numberWithCommas(String(tempData.cpmTotal)),//累计cpm
                    cpcTotal:util.numberWithCommas(String(tempData.cpcTotal)),//累计点击单价
                    cpm:util.numberWithCommas(String(tempData.cpm)), //累计每千曝光金额
                    clickPv:util.numberWithCommas(String(tempData.clickPv)),//累计点击PV
                    cpcRate:util.numberWithCommas(String(tempData.cpcRate)),//累计点击单价
                })
            }
          } else {
            wx.showToast({
              title: data.msg,
              icon: 'none',
              duration: 1500
            })
          }
        });

        let trendData = {"beginDate":"2019-01-01","endDate":yesterdayStr};
        request.Get(api.customerTrend(),trendData, function (data) {
            console.log("data>>>>>>>>>>",JSON.stringify(data));
            // let tempValue = {"code":"200",
            // "msg":"success",
            // "data":[{"date":"2019-03-10","consume":"50"},
            // {"date":"2019-03-11","consume":"51"},
            // {"date":"2019-03-12","consume":"53"},
            // {"date":"2019-03-13","consume":"55"},
            // {"date":"2019-03-14","consume":"59"},
            // {"date":"2019-03-15","consume":"60"},
            // {"date":"2019-03-16","consume":"63"},]}
            if (data.code == '200') {
                var tempData = data.data.map(item => {
                    return {date:item.date,value:item.consume}
                });
                let dateArray = data.data.map(item => {
                    return item.date;
                })
                that.setData({
                    chartsData:tempData,
                    chartsDateArray:dateArray
                })
                that.drawCharts();

            }else{
                wx.showToast({
                    title: data.msg,
                    icon: 'none',
                    duration: 1500
                  })
            }
        })
      },


})