const util = require('../../utils/util');
const request = require('../../utils/request');
const api = require('../../utils/api');
const yesterday = new Date(Date.now() - 864e5);
const todayStr = util.formatTime(new Date(Date.now()));
const yesterdayStr = util.formatTime(yesterday);

Page({
    data: {
        date: yesterdayStr,
        currentDate: yesterdayStr,
        groupArray: [], // 计划名称数组
        groupIndex: 0,
        currentGroupId:'',
        groupData: [], // 计划对象数组
        planArray:[],
        planIndex:0,
        currentPlanId:'',
        planData:[],

        opts: {
            lazyLoad: true // 延迟加载组件
        },
        chartsData: [],
        chartsDateArray: [],

        consumeTotal:'', //累计消耗金额
        showPvTotal:'',//累计曝光PV
        showUvTotal:'',//累计曝光UV
        showPerCapitaTotal:'',//累计人均曝光次数
        clickPvTotal:'',//累计点击PV
        clickUvTotal:'',//累计点击UV
        clickRateTotal:'',//累计点击率
        callRateTotal:'',//累计唤端率
        cpmTotal:'',//累计千次曝光金额
        cpcTotal:'',
    },
    onReady() {
        this.queryPlanData();
    },

    dateSelected(e){
        this.setData({
            date: e.detail.value,
            currentDate: e.detail.value
        })
        this.groupTotal(this.data.currentGroupId,e.detail.value);
        this.groupDayTrend(this.data.currentGroupId,e.detail.value);
    },
    planPickerChange(e) {
        let index = e.detail.value;
        console.log("planPickerChange>>>>>>>>>>>>>>",index);
        this.setData({
            planIndex:index,
            currentPlanId:this.data.planData[index].id
         })
       this.queryGroupSimple(this.data.currentPlanId);
    },

    groupPickerChange(e){
        let index = e.detail.value;
        this.setData({
            groupIndex:index,
            currentGroupId:this.data.groupData[index].id
         })
         this.groupTotal(this.data.groupData[index].id,this.data.currentDate);
         this.groupDayTrend(this.data.groupData[index].id,this.data.currentDate);
    },
    // 推广计划下拉
    queryPlanData() {
        wx.showLoading({
            title: '加载中',
        })
        var that = this;
        request.Get(api.campaignSimple(), function (res) {
            wx.hideLoading();
            console.log("queryPlanData>>>>>>>>>>>>",JSON.stringify(res));
            if (res.code == '200') {
                if (res.data.length == 0) {
                    wx.showToast({
                        title: "没有推广计划可查询",
                        icon: 'none',
                        duration: 1500
                    })
                } else {
                    that.setData({
                        planData: res.data,
                        planArray: res.data.map(item => { return item.name }),
                        currentPlanId: res.data[0].id
                    })
                    that.queryGroupSimple(res.data[0].id);
                }
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },
    // 推广组下拉
    queryGroupSimple(planId) {
        var that = this;
        let data = {'campaignId':planId};
        request.Get(api.groupSimple(),data,function (res) {
            wx.hideLoading();
            console.log("queryGroupSimple>>>>>>>>>>>>",JSON.stringify(res));
            
            if (res.code == '200') {
                if (res.data.length == 0) {
                    wx.showToast({
                        title: "没有推广组可查询",
                        icon: 'none',
                        duration: 1500
                    })
                } else {
                    that.setData({
                        groupData: res.data,
                        groupArray: res.data.map(item => { return item.name }),
                        currentGroupId:res.data[0].id
                    })
                    that.groupTotal(res.data[0].id,that.data.currentDate);
                    that.groupDayTrend(res.data[0].id,that.data.currentDate);
                    // console.log("that.data.planData>>>>>>",JSON.stringify(that.data.groupData));
                }
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },

    groupTotal(groupid,dateStr) {
        var that = this;
        let data = { 'date': dateStr, 'id': groupid };
        request.Get(api.reportGroupTotal(), data, function (res) {
            if (res.code == '200') {
                console.log("groupTotal>>>>>>>>>>>",JSON.stringify(res));
                that.setData({
                    consumeTotal: util.numberWithCommas(String(res.data.consumeTotal)),
                    showPvTotal: util.numberWithCommas(String(res.data.showPvTotal)),
                    showUvTotal: util.numberWithCommas(String(res.data.showUvTotal)),
                    showPerCapitaTotal: util.numberWithCommas(String(res.data.showPerCapitaTotal)),
                    clickPvTotal: util.numberWithCommas(String(res.data.clickPvTotal)),
                    clickUvTotal: util.numberWithCommas(String(res.data.clickUvTotal)),
                    clickRateTotal: util.numberWithCommas(String(res.data.clickRateTotal)),
                    callRateTotal: util.numberWithCommas(String(res.data.callRateTotal)),
                    cpmTotal: util.numberWithCommas(String(res.data.cpmTotal)),
                    cpcTotal: util.numberWithCommas(String(res.data.cpcTotal)),
                })
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        });
    },


    groupDayTrend(groupId,dateStr) {
        var that = this;
        let data = { 'beginDate': '2019-03-01', 'endDate': dateStr, 'id': groupId };
        request.Get(api.campaignTrend(), data, function (res) {
            // console.log("queryPlanTrend>>>>>>>>>>>", JSON.stringify(res));
            if (res.code == '200') {
                var tempData = res.data.map(item => {
                    return { date: item.date, value: item.consume }
                });
                let dateArray = res.data.map(item => {
                    return item.date;
                })
                that.setData({
                    chartsData: tempData,
                    chartsDateArray: dateArray
                })
                that.drawCharts();
            } else {
                wx.showToast({
                    title: res.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        })
    },

    drawCharts() {
        const self = this;
        self.chartComponent = self.selectComponent('#line-dom');
        self.chartComponent.init((canvas, width, height, F2) => {
            // console.log("chartsData>>>>>>>>>>", self.data.chartsData);
            const data = self.data.chartsData;
            let chart = new F2.Chart({
                el: canvas,
                width,
                height
            });
            chart.source(data, {
                date: {
                    range: [0, 1],
                    ticks: self.data.chartsDateArray
                },
                value: {
                    tickCount: 10,
                    formatter(val) {
                        return val;//val.toFixed(1);
                    }
                }
            });
            chart.line().position('date*value').color('type', val => {
                return 'red';
            });
            chart.render();
            return chart;
        });
    }





})